From 6e0dee7845cea22f59bd353ef42b31cb67170030 Mon Sep 17 00:00:00 2001
From: Andreas Schneider <asn@cryptomilk.org>
Date: Thu, 2 Apr 2015 15:02:29 +0200
Subject: poll: Fix compilation with struct ssh_timestamp

Signed-off-by: Andreas Schneider <asn@cryptomilk.org>
(cherry picked from commit e0a73d3dbe909f8e2cb486ed344e5beb8148032e)
---
 src/poll.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/src/poll.c b/src/poll.c
index dfa687a..05faba7 100644
--- a/src/poll.c
+++ b/src/poll.c
@@ -35,9 +35,9 @@
 #include "libssh/poll.h"
 #include "libssh/socket.h"
 #include "libssh/session.h"
+#include "libssh/misc.h"
 #ifdef WITH_SERVER
 #include "libssh/server.h"
-#include "libssh/misc.h"
 #endif
 
 
-- 
cgit v0.11.2