diff -Naurd mpfr-4.1.0-a/PATCHES mpfr-4.1.0-b/PATCHES
--- mpfr-4.1.0-a/PATCHES	2021-02-11 12:40:40.079363480 +0000
+++ mpfr-4.1.0-b/PATCHES	2021-02-11 12:40:40.119363040 +0000
@@ -0,0 +1 @@
+decimal128-conv
diff -Naurd mpfr-4.1.0-a/VERSION mpfr-4.1.0-b/VERSION
--- mpfr-4.1.0-a/VERSION	2020-07-10 11:52:33.000000000 +0000
+++ mpfr-4.1.0-b/VERSION	2021-02-11 12:40:40.119363040 +0000
@@ -1 +1 @@
-4.1.0
+4.1.0-p1
diff -Naurd mpfr-4.1.0-a/src/get_d128.c mpfr-4.1.0-b/src/get_d128.c
--- mpfr-4.1.0-a/src/get_d128.c	2020-04-08 22:39:35.000000000 +0000
+++ mpfr-4.1.0-b/src/get_d128.c	2021-02-11 12:40:40.103363216 +0000
@@ -40,22 +40,21 @@
 static _Decimal128
 get_decimal128_nan (void)
 {
-  return (_Decimal128) MPFR_DBL_NAN;
+  return 0.0dl / 0.0dl;
 }
 
 /* construct the decimal128 Inf with given sign */
 static _Decimal128
 get_decimal128_inf (int negative)
 {
-  return (_Decimal128) (negative ? MPFR_DBL_INFM : MPFR_DBL_INFP);
+  return negative ? - 1.0dl / 0.0dl : 1.0dl / 0.0dl;
 }
 
 /* construct the decimal128 zero with given sign */
 static _Decimal128
 get_decimal128_zero (int negative)
 {
-  _Decimal128 zero = 0;
-  return (_Decimal128) (negative ? -zero : zero);
+  return negative ? - 0.0dl : 0.0dl;
 }
 
 /* construct the decimal128 smallest non-zero with given sign:
diff -Naurd mpfr-4.1.0-a/src/mpfr.h mpfr-4.1.0-b/src/mpfr.h
--- mpfr-4.1.0-a/src/mpfr.h	2020-07-10 11:52:33.000000000 +0000
+++ mpfr-4.1.0-b/src/mpfr.h	2021-02-11 12:40:40.115363084 +0000
@@ -27,7 +27,7 @@
 #define MPFR_VERSION_MAJOR 4
 #define MPFR_VERSION_MINOR 1
 #define MPFR_VERSION_PATCHLEVEL 0
-#define MPFR_VERSION_STRING "4.1.0"
+#define MPFR_VERSION_STRING "4.1.0-p1"
 
 /* User macros:
    MPFR_USE_FILE:        Define it to make MPFR define functions dealing
diff -Naurd mpfr-4.1.0-a/src/version.c mpfr-4.1.0-b/src/version.c
--- mpfr-4.1.0-a/src/version.c	2020-07-10 11:52:33.000000000 +0000
+++ mpfr-4.1.0-b/src/version.c	2021-02-11 12:40:40.119363040 +0000
@@ -25,5 +25,5 @@
 const char *
 mpfr_get_version (void)
 {
-  return "4.1.0";
+  return "4.1.0-p1";
 }